//Copyright (C) 2020-2023 vamX - All Rights Reserved
//Sorry for the slight obfuscation, but this is commercial software that took a LONG time to write. You may NOT distribute or reuse any of this code.
using System; using System.Collections; using System.Collections.Generic; using System.Linq; using UnityEngine; using UnityEngine.Windows.Speech; using MVR.FileManagementSecure; using MVR.Hub; namespace vamX { public class BL_VoiceControl : MVRScript { public static BL_VoiceControl latestInstance = null; public static void DownloadVoiceCommandResources() { } public static void StopSimpleMalePhraseIfPending() { } private static List<string> extraItemPrefixes = new List<string>(); private static bool alsoUseOriginalItem = false; struct ActionPhrase { public int phraseIndex; public List<string> phrases; public List<string> llmPhrases; public Action action; public ActionPhrase(int _phraseIndex, List<string> _phrases, Action _action, List<string> _llmPhrases = null, bool keepOriginalPhrasesForPrefix = false) { phraseIndex = _phraseIndex; phrases = new List<string>(); action = _action; llmPhrases = _llmPhrases; if (!keepOriginalPhrasesForPrefix && alsoUseOriginalItem) { keepOriginalPhrasesForPrefix = true; } try { if (extraItemPrefixes.Count > 0) { if (keepOriginalPhrasesForPrefix && _phrases != null && _phrases.Count > 0) phrases.AddRange(_phrases); for (int i = 0; i < extraItemPrefixes.Count; i++) { if (_phrases != null && _phrases.Count > 0) { for (int j = 0; j < _phrases.Count; j++) { if (!string.IsNullOrEmpty(_phrases[j]) && !_phrases[j].StartsWith("dress like") && !_phrases[j].StartsWith("wear") && !_phrases[j].StartsWith("Wear")) { phrases.Add(extraItemPrefixes[i] + _phrases[j]); } } } } } else { if (_phrases != null && _phrases.Count > 0) phrases = _phrases; } if (_llmPhrases == null) { if (phrases.Count > 0) llmPhrases = new List<string>() { phrases[0] }; if (phrases.Count > 1) { llmPhrases.Add(phrases[1]); } } } catch (Exception e) { com.ShowDebugError("Exception caught in ActionPhrase(): " + e); } } } Dictionary<int, List<string>> phraseActions = new Dictionary<int, List<string>>(); List<ActionPhrase> actionPhrases = new List<ActionPhrase>(); bool builtPhraseActions = false; bool builtLLMActionList = false; public const int PHRASE_FEMALE_EMO_HAPPY = 622; public const int PHRASE_FEMALE_EMO_SAD = 623; public const int PHRASE_FEMALE_EMO_AFRAID = 624; public const int PHRASE_FEMALE_EMO_ANGRY = 625; public const int PHRASE_FEMALE_EMO_ANNOYED = 626; public const int PHRASE_FEMALE_EMO_FLIRTY = 627; public const int PHRASE_FEMALE_EMO_HOPEFUL = 628; public const int PHRASE_FEMALE_EMO_INTERESTED = 629; public const int PHRASE_FEMALE_EMO_PLEASURE = 630; const int PHRASE_REPEAT = 0; const int PHRASE_END = 3000; static int phraseCounter = PHRASE_END; int lastDetectedPhrase = -1; public override void Init() { latestInstance = this; } public Dictionary<int, List<string>> GetStandardPhraseActions() { Dictionary<int, List<string>> phraseActions = new Dictionary<int, List<string>>() { }; actionPhrases = new List<ActionPhrase>() { }; foreach (ActionPhrase actionPhrase in actionPhrases) { phraseActions.Add(actionPhrase.phraseIndex, actionPhrase.phrases); } return phraseActions; } public void ProcessPhrase(int phraseIndex, string phrase, ConfidenceLevel confidence, bool isLLMAction = false, bool isLLMFemaleSpeaking = true) { ; if (phraseIndex == PHRASE_REPEAT) { phraseIndex = lastDetectedPhrase; } if (string.IsNullOrEmpty(phrase)) { if (phraseActions.ContainsKey(phraseIndex)) { if (phraseActions[phraseIndex].Count > 0) { phrase = phraseActions[phraseIndex][0]; ; } } } switch (phraseIndex) { case PHRASE_FEMALE_EMO_HAPPY: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859); break; case PHRASE_FEMALE_EMO_SAD: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a865); break; case PHRASE_FEMALE_EMO_AFRAID: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a842); break; case PHRASE_FEMALE_EMO_ANGRY: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a854); break; case PHRASE_FEMALE_EMO_ANNOYED: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a855); break; case PHRASE_FEMALE_EMO_FLIRTY: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a858); break; case PHRASE_FEMALE_EMO_HOPEFUL: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a860); break; case PHRASE_FEMALE_EMO_INTERESTED: BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a861); break; case PHRASE_FEMALE_EMO_PLEASURE: List<int> emotionList = new List<int>() { a137.a869, a137.a870, a137.a850 }; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, emotionList[UnityEngine.Random.Range(0, emotionList.Count)]); break; } } public void BuildPhraseActions() { if (!builtPhraseActions) { ; phraseActions = GetStandardPhraseActions(); List<string> newItems = new List<string>(); foreach (KeyValuePair<int, List<string>> kvp in phraseActions) { if (newItems.Count > 0) { kvp.Value.AddRange(newItems); newItems.Clear(); } } ; builtPhraseActions = true; } else { ; } } public void BuildLLMActions() { BuildPhraseActions(); builtLLMActionList = true; } public bool TryRespondToEmotion(string actionName) { List<string> fixedEmotionResponseList = new List<string>() { "neutral", "happy", "sad", "afraid", "terrified", "calm", "angry", "caring", "disgusted", "aroused", "excited", "horny", "interested", "shy", "confident", "aloof", "annoyed", "confused", "frustrated", "surprised", "hurts", "pleasure", "feels good", "definitely no", "no way", "i'd like that", "happily", "don't do that", "stop that", "oh god", "i love you", "hopeful", "i'm sorry", "contempt", "unhappy", "bored", "flirtatious", "dominating", "pleasantly surprised", "definitely yes", "let's do that", "yummy", "bites her lip", "her", "you're sexy", "you're", "I'm sexy", "I'm", "appreciative" }; bool responded = false; if (fixedEmotionResponseList.Contains(actionName)) { List<int> pleasureEmotionList = new List<int>() { a137.a869, a137.a870, a137.a850 }; float arousalChangeVerySmall = 0.05f; float arousalChangeSmall = 0.07f; float arousalChangeMedium = 0.1f; float arousalChangeLarge = 0.175f; float arousalChangeHuge = 0.3f; responded = true; switch (actionName) { case "neutral": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a1732CLEAR_MOOD); break; case "happy": com.arousal += arousalChangeVerySmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859); break; case "sad": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a865); break; case "afraid": com.arousal -= arousalChangeHuge; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a842); break; case "terrified": com.arousal -= arousalChangeHuge; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a841); break; case "calm": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a1732CLEAR_MOOD); break; case "angry": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a854); break; case "caring": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859); break; case "disgusted": com.arousal -= arousalChangeHuge; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a857); break; case "aroused": com.arousal += arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a849); if (com.arousal < 0.3f) com.arousal = 0.3f; break; case "excited": com.arousal += arousalChangeSmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a825); break; case "horny": com.arousal += arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a827); if (com.arousal < 0.5f) com.arousal = 0.5f; break; case "interested": com.arousal += arousalChangeVerySmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a861); break; case "shy": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a860); break; case "confident": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a820); break; case "aloof": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a856); break; case "annoyed": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a855); break; case "confused": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a832); break; case "frustrated": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a845); break; case "surprised": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a830); break; case "hurts": com.arousal -= arousalChangeHuge; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a863); break; case "pleasure": com.arousal += arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.VOICE_COMMAND_a858_PLEASURE_BREATH); break; case "feels good": com.arousal += arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a829); break; case "definitely no": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a845); break; case "no way": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a855); break; case "i'd like that": com.arousal += arousalChangeVerySmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859); break; case "happily": com.arousal += arousalChangeVerySmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a858); break; case "don't do that": com.arousal -= arousalChangeHuge; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a868); break; case "stop that": com.arousal -= arousalChangeHuge; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a854); break; case "oh god": com.arousal += arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a851); break; case "i love you": com.arousal += arousalChangeSmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a860); break; case "hopeful": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a860); break; case "i'm sorry": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a837); break; case "contempt": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a856); break; case "unhappy": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a868); break; case "bored": com.arousal -= arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a855); break; case "flirtatious": com.arousal += arousalChangeSmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a858); break; case "dominating": BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a820); break; case "pleasantly surprised": com.arousal += arousalChangeSmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859_SURPRISE); break; case "definitely yes": com.arousal += arousalChangeVerySmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859); break; case "let's do that": com.arousal += arousalChangeVerySmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859); break; case "yummy": com.arousal += arousalChangeSmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a827); break; case "bites her lip": com.arousal += arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a849); break; case "her": responded = false; break; case "you're sexy": com.arousal += arousalChangeMedium; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a827); if (com.arousal < 0.5f) com.arousal = 0.5f; break; case "you're": responded = false; break; case "I'm sexy": com.arousal += arousalChangeSmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a858); break; case "I'm": responded = false; break; case "appreciative": com.arousal += arousalChangeVerySmall; BL_GUI.LoadPersonMood(com.FEMALE_INDEX, a137.a859); break; default: com.ShowDebugError("LLM should have found action response to fixedEmotionResponseList but it hasn't been created yet: " + actionName); responded = false; break; } if (responded) { if (com.arousal >= 1.0f) { } ; ; } } else { com.ShowDebugError("LLM should have found action response to fixedEmotionResponseList but the lists don't match: " + actionName); } return responded; } public static Dictionary<string, string> aiActionMap = new Dictionary<string, string>() { { "I'm going to cum", "Orgasm" }, { "I'm gonna cum", "Orgasm" }, { "I'm cumming", "Orgasm" } }; public bool TryRespondToUserSelfAction(string actionName) { bool responded = false; return responded; } public void LLMAction(string actionName, int actionTag, bool testOnly = false) { try { switch (actionTag) { case 0: ; bool respondedToEmotion = TryRespondToEmotion(actionName); if (respondedToEmotion) { ; } return; case 1: ; foreach (KeyValuePair<string, string> kvp in aiActionMap) { if (kvp.Key.Equals(actionName, StringComparison.OrdinalIgnoreCase)) { actionName = kvp.Value; break; } } break; case 2: ; bool respondedToUserSelfAction = TryRespondToUserSelfAction(actionName); if (respondedToUserSelfAction) { ; } return; case 3: ; break; } ; List<string> negativeKeywords = new List<string>() { "Next", "lift your dress up", "You're sexy", "That's sexy" }; if (negativeKeywords.Contains(actionName, StringComparer.OrdinalIgnoreCase)) { ; return; } bool foundMatch = false; foreach (KeyValuePair<int, List<string>> kvp in phraseActions) { if (kvp.Value.Contains(actionName, StringComparer.OrdinalIgnoreCase)) { foundMatch = true; int phraseIndex = kvp.Key; if (phraseIndex == PHRASE_REPEAT) { phraseIndex = lastDetectedPhrase; } ; if (!testOnly) ProcessPhrase(phraseIndex, actionName, ConfidenceLevel.Medium, true, actionTag == 1); } } if (!foundMatch) { foreach (KeyValuePair<int, List<string>> kvp2 in phraseActions) { foreach (string phraseAction in kvp2.Value) { if (phraseAction.IndexOf(actionName, StringComparison.OrdinalIgnoreCase) >= 0) { foundMatch = true; int phraseIndex = kvp2.Key; if (phraseIndex == PHRASE_REPEAT) { phraseIndex = lastDetectedPhrase; } ; if (!testOnly) ProcessPhrase(phraseIndex, actionName, ConfidenceLevel.Medium, true, actionTag == 1); } } } } if (!foundMatch) { ; com.ShowDebugError("Didn't find voice command action to match LLM action: " + actionName + ". Probably due to most actions being disabled in the non-vamX version."); } } catch (Exception e) { SuperController.LogError("Exception caught: " + e); } } } } 