//Copyright (C) 2020-2023 vamX - All Rights Reserved
//Sorry for the slight obfuscation, but this is commercial software that took a LONG time to write. You may NOT distribute or reuse any of this code.
using MVR.FileManagementSecure; using SimpleJSON; using System; using System.Collections; using System.Collections.Generic; using System.Linq; using System.Net.Sockets; using System.Text; using UnityEngine; using UnityEngine.UI; using static UnityEngine.UI.Button; namespace vamX { public class Imposter : MVRScript { public static Imposter latestInstance = null; public const bool IN_VAMX = true; public static bool usingImposter = false; protected TcpClient client; protected NetworkStream stream; string microphoneDeviceSystemDefault = "System Default"; JSONStorableString _serverURL; string secret = "982lksjdfs823dsf98-239sdssd-329832"; const string DEFAULT_HOSTNAME = "llmserve.com"; const string DEFAULT_EU_HOSTNAME = "llmservers.com"; public static string hostname = "llmserve.com"; public static string hostname_button_override = ""; const string DEFAULT_PERSONALITIES = "http://llmserve.b-cdn.net/pers/_index.text"; static string personalitiesURL = DEFAULT_PERSONALITIES; const string DEFAULT_USER_NAME = ""; static string myName = DEFAULT_USER_NAME; static string password = ""; static string custom_llm_ip = ""; static string chatgpt_4_openai_key = ""; static string elevenlabs_key = ""; public static string a1651AtomID = "vamXWebPanel__vamX Plugin"; public const string IMPOSTER_SUBSCENE_UID = "AIChatSubScene"; static Atom subScene = null; List<string> allActions; public static bool IsImposterOnAndUsingWebPanel() { return usingImposter && !com.USE_IMPOSTER_SUBSCENE; } public void GenerateActionList() { } class EmotionAction { const int Passionate = 0; const int Angry = 1; const int Anxious = 2; const int Ashamed = 3; const int Bored = 4; const int Calm = 5; const int Cheerful = 6; const int Confident = 7; const int Confused = 8; const int Curious = 9; const int Defensive = 10; const int Depressed = 11; const int Desperate = 12; const int Determined = 13; } public void Start() { if (com.USE_IMPOSTER_SUBSCENE) { StartImposter(); } } public void StartImposter() { StartCoroutine(StartImposterCoRoutine()); } public void StartImposterFromButton() { if (usingImposter) { BL_GUI.SwitchTab(BL_GUI.a1732a1733AI_CHAT); string instructionsText = "\nPress USA or Europe to restart and reconnect the AI Chat."; BL_GUI.SetInstructionsText(instructionsText, false, default(Color), true, false, false); } else { StartCoroutine(StartImposterCoRoutine()); } } public static void LogImposter(string message) { ; } public static void LogError(string message) { com.ShowError("Imposter Error: " + message); } public static bool stoppedMaleVoice = false; public IEnumerator StartImposterCoRoutine() { ; BL_VoiceControl.DownloadVoiceCommandResources(); BL_GUI.SwitchTab(BL_GUI.a1732a1733AI_CHAT); if (hostname_button_override != "") { hostname = hostname_button_override; } else if (FileManagerSecure.FileExists(com.AI_CHAT_HOST_FILE)) { hostname = FileManagerSecure.ReadAllText(com.AI_CHAT_HOST_FILE); if (hostname == "Default") { if (com.USE_IMPOSTER_SUBSCENE) { hostname = DEFAULT_EU_HOSTNAME; } else { hostname = DEFAULT_HOSTNAME; } } } else { FileManagerSecure.WriteAllText(com.AI_CHAT_HOST_FILE, "Default"); hostname = DEFAULT_HOSTNAME; } if (FileManagerSecure.FileExists(com.AI_CHAT_KEY_FILE)) { secret = FileManagerSecure.ReadAllText(com.AI_CHAT_KEY_FILE); } else { secret = Guid.NewGuid().ToString(); FileManagerSecure.WriteAllText(com.AI_CHAT_KEY_FILE, secret); } if (FileManagerSecure.FileExists(com.AI_CHAT_PERSONALITIES_FILE)) { personalitiesURL = FileManagerSecure.ReadAllText(com.AI_CHAT_PERSONALITIES_FILE); if (personalitiesURL == "Default") { personalitiesURL = DEFAULT_PERSONALITIES; } } else { FileManagerSecure.WriteAllText(com.AI_CHAT_PERSONALITIES_FILE, "Default"); personalitiesURL = DEFAULT_PERSONALITIES; } if (FileManagerSecure.FileExists(com.AI_CHAT_NAME_FILE)) { myName = FileManagerSecure.ReadAllText(com.AI_CHAT_NAME_FILE); if (myName == "{Dynamic}") { myName = DEFAULT_USER_NAME; } if (myName.StartsWith("http://llmserve")) { FileManagerSecure.WriteAllText(com.AI_CHAT_NAME_FILE, DEFAULT_USER_NAME); myName = DEFAULT_USER_NAME; } } else { FileManagerSecure.WriteAllText(com.AI_CHAT_NAME_FILE, "{Dynamic}"); myName = DEFAULT_USER_NAME; } if (FileManagerSecure.FileExists(com.AI_CHAT_PASSWORD_FILE)) { password = FileManagerSecure.ReadAllText(com.AI_CHAT_PASSWORD_FILE); } else { FileManagerSecure.WriteAllText(com.AI_CHAT_PASSWORD_FILE, ""); password = ""; } if (FileManagerSecure.FileExists(com.AI_CHAT_CHAT_CUSTOM_LLM_IP_FILE)) { custom_llm_ip = FileManagerSecure.ReadAllText(com.AI_CHAT_CHAT_CUSTOM_LLM_IP_FILE); } else { FileManagerSecure.WriteAllText(com.AI_CHAT_CHAT_CUSTOM_LLM_IP_FILE, ""); custom_llm_ip = ""; } if (FileManagerSecure.FileExists(com.AI_CHAT_CHATGPT_4_API_KEY_FILE)) { chatgpt_4_openai_key = FileManagerSecure.ReadAllText(com.AI_CHAT_CHATGPT_4_API_KEY_FILE); } else { FileManagerSecure.WriteAllText(com.AI_CHAT_CHATGPT_4_API_KEY_FILE, ""); chatgpt_4_openai_key = ""; } if (FileManagerSecure.FileExists(com.AI_CHAT_ELEVENLABS_API_KEY_FILE)) { elevenlabs_key = FileManagerSecure.ReadAllText(com.AI_CHAT_ELEVENLABS_API_KEY_FILE); } else { FileManagerSecure.WriteAllText(com.AI_CHAT_ELEVENLABS_API_KEY_FILE, "None"); elevenlabs_key = "None"; } com.LogAlways("Connect to imposter at: " + hostname + " with key " + secret); if (com.USE_IMPOSTER_SUBSCENE) { a1651AtomID = IMPOSTER_SUBSCENE_UID + "/Browser"; subScene = SuperController.singleton.GetAtomByUid(IMPOSTER_SUBSCENE_UID); bool needsLoadSubScene = false; if (subScene == null) { ; yield return SuperController.singleton.AddAtomByType("SubScene", IMPOSTER_SUBSCENE_UID); subScene = SuperController.singleton.GetAtomByUid(IMPOSTER_SUBSCENE_UID); needsLoadSubScene = true; } if (needsLoadSubScene) { ; vamX.com.LoadSubScene(subScene, vamX.com.GetCorrectPath("Custom/SubScene/vamX/Twinwin/ImposterSubScene/ImposterSubScene.json", false)); while (SuperController.singleton.GetAtomByUid(a1651AtomID) == null) { ; yield return new WaitForEndOfFrame(); yield return new WaitForSecondsRealtime(0.01f); } } yield return new WaitForSecondsRealtime(0.5f); if (subScene == null) com.ShowError("Missing imposter subscene atom: " + IMPOSTER_SUBSCENE_UID); } string url = "http://" + hostname + ":8080/?secret=" + secret; if (personalitiesURL != "") { url += "&personalities=" + personalitiesURL; } if (a1651AtomID == BL_GUI.WEB_PANEL_ID) { BL_Save.JSONBoolUsingImposterOnDefaultWebPanel.SetVal(true); BL_GUI.ShowWebPanel(); ; JSONStorable musicManager = com.FindPluginInScene("vamX.a129"); if (musicManager != null) { musicManager.SetStringParamValue("Web Page URL", a129.a1153); musicManager.CallAction("JSONActionForceOpenURL"); musicManager.SetStringParamValue("Web Page URL", url); musicManager.CallAction("JSONActionForceOpenURL"); } ; } else { Atom a1651 = GetAtomById(a1651AtomID); VRWebBrowser vRWebBrowser = (VRWebBrowser)a1651.GetStorableByID("BrowserGUI"); vRWebBrowser.url = ""; vRWebBrowser.url = url; } yield return new WaitForSecondsRealtime(0.5f); yield return new WaitForEndOfFrame(); yield return new WaitForFixedUpdate(); while (SuperController.singleton.isLoading) { yield return new WaitForEndOfFrame(); yield return new WaitForFixedUpdate(); } connect(); InitMicrophone(); if (!stoppedMaleVoice) { com.StopMaleVoice(); stoppedMaleVoice = true; } com.moansOnly = true; string instructionsText = "AI Chat is shown in the web browser window. Type or speak the password from your vamX AI Chat monthly subscription. "; if (com.IsDesktopMode()) { instructionsText += "To speak, hold the right mouse button while speaking."; } else { instructionsText += "To speak, hold the VR Controller trigger button while speaking. Press \"Hide\" to stop the menu from toggling."; } if (hostname_button_override != "") { instructionsText = "The European servers should be used by people in Europe, or people in the US if the US servers are busy (slow). The USA servers are loaded by default when restarting. Learn to change the default server to the European or USA servers at https://sxvr.com/ai"; } BL_GUI.SetInstructionsTextSmall(instructionsText, false, default(Color), true, false, false); usingImposter = true; BL_GUI.RefreshFemaleVoiceVolume(true); yield return null; } public override void Init() { try { latestInstance = this; _serverURL = new JSONStorableString("ServerURL", hostname, (string serverURL) => { connect(); }); RegisterString(_serverURL); UIDynamicButton usServers = CreateButton("Connect to US Servers"); ButtonClickedEvent usServersClickedEvent = new ButtonClickedEvent(); usServersClickedEvent.AddListener(() => { hostname_button_override = DEFAULT_HOSTNAME; StartImposter(); }); usServers.button.onClick = usServersClickedEvent;                 UIDynamicButton euServers = CreateButton("Connect to EU Servers"); ButtonClickedEvent euServersClickedEvent = new ButtonClickedEvent(); euServersClickedEvent.AddListener(() => { hostname_button_override = DEFAULT_EU_HOSTNAME; StartImposter(); }); euServers.button.onClick = euServersClickedEvent; List<string> microphoneDeviceNames = new List<string> { microphoneDeviceSystemDefault }; foreach (string deviceName in Microphone.devices) { microphoneDeviceNames.Add(deviceName); } _microphoneDeviceChooser = new JSONStorableStringChooser("MicrophoneDevice", microphoneDeviceNames, microphoneDeviceSystemDefault, "Microphone Device", InitMicrophone); RegisterStringChooser(_microphoneDeviceChooser); CreatePopup(_microphoneDeviceChooser); List<string> colliderChoices = new List<string>() { "p243", "p244", "p245", "p246", "p247", "p248", "p249", "p250", "p251", "p252", "p253" }; _speakerIdChooser = new JSONStorableStringChooser("SpeakerID", colliderChoices, "p243", "Speaker ID"); RegisterStringChooser(_speakerIdChooser); _sendActions = new JSONStorableBool("Send Actions", true); RegisterBool(_sendActions); allActions = new List<string>() { "LookToMe", "LookAway", "SadFace", "AngryFace", "HappyFace", "ExcitedFace", "FearFace", "RegularFace", "IncludePhysical", "DontIncludeAppearance" }; string listOfActions = "Available actions:\n"; if (allActions.Count > 0) { listOfActions += allActions.Aggregate((acc, x) => acc + "\n" + x); } JSONStorableString jSONStorable = new JSONStorableString("actionsTextField", listOfActions); _sendTriggers = new JSONStorableBool("Send Triggers", true, (bool active) => { if (!active) { clearAllTriggers(); } else { addAllTriggers(); } }); RegisterBool(_sendTriggers); _triggersTextField = new JSONStorableString("triggersTextField", "Available Triggers:"); _pushToTalkToggle = new JSONStorableBool("Push To Talk", true); RegisterBool(_pushToTalkToggle); CreateSpacer(true); } catch (Exception e) { LogError(e.Message); } } private IEnumerator handshake(float waitTime) { yield return new WaitForSeconds(waitTime); JSONNode jSONNode = JSON.Parse("{}"); jSONNode.Add("type", "handshake"); jSONNode.Add("payload", "vam"); jSONNode.Add("secret", secret); jSONNode.Add("myName", myName); jSONNode.Add("password", password); jSONNode.Add("custom_llm_ip", custom_llm_ip); jSONNode.Add("chatgpt_4_openai_key", chatgpt_4_openai_key); jSONNode.Add("elevenlabs_key", elevenlabs_key); JSONNode config = getConfig(); jSONNode.Add("config", config); ; sendJSON(jSONNode.ToString()); } public static void ProcessActionVamX(string originalActionName, bool immediately = false) { string actionName = originalActionName; ; int actionTag = 3; if (actionName.StartsWith("[")) { int actionTagInt = 3; if (int.TryParse(actionName[1].ToString(), out actionTagInt)) { actionTag = actionTagInt; } actionName = actionName.Substring(3); } ; if (actionTag == 0 || immediately) { ; BL_VoiceControl.latestInstance.LLMAction(actionName, actionTag); } else { actionListForVoiceCommands.Add(originalActionName); } } private IEnumerator triggerActionWithCoroutine(float waitTime, string actionName) { yield return new WaitForSeconds(waitTime); try { ProcessActionVamX(actionName); } catch (Exception e) { ; } } private void onMessageReceived(string message) { try { JSONNode jSONNode = JSON.Parse(message); string transcript = jSONNode["text"]; string actionName = jSONNode["action"]; if (actionName != null && !actionName.Equals("")) { StartCoroutine(triggerActionWithCoroutine(0.1f, actionName)); return; } string type = jSONNode["type"]; if (type != null && type.Equals("wav")) { ; int sampleRate = jSONNode["sampleRate"].AsInt; int bitDepth = jSONNode["bitDepth"].AsInt; int channels = jSONNode["channels"].AsInt; ; string payloadBase64 = jSONNode["payload"]; byte[] byteArray = Convert.FromBase64String(payloadBase64); float[] floatArray = new float[byteArray.Length / 2]; for (int i = 0; i < byteArray.Length; i += 2) { byte[] tempBytes = { byteArray[i], byteArray[i + 1] }; short value = BitConverter.ToInt16(tempBytes, 0); float valueFloat = value / (float)32768; floatArray[i / 2] = valueFloat; } string source = jSONNode["source"]; ; if (source == "elevenlabs") { ; for (int i = 0; i < 44; i++) { if (i < floatArray.Length) { floatArray[i] = 0; } } } AudioClip receivedAudioClip = AudioClip.Create("nodeJS", floatArray.Length, channels, sampleRate, false); receivedAudioClip.SetData(floatArray, 0); if (headAudio == null) { ; headAudio = com.femAtom.GetStorableByID("HeadAudioSource"); } audioClipDisplayNameIndex++; NamedAudioClip nac = new NamedAudioClip { sourceClip = receivedAudioClip, displayName = "chat_" + audioClipDisplayNameIndex }; a4342List.Add(nac); audioClipStartTime = Time.time; a137.headAudios[com.FEMALE_INDEX].lastChatAudioLoadTime = Time.time; ; } } catch (Exception e) { LogError("Imposter audio play error. " + e.Message); } } JSONStorable headAudio; public static List<string> actionListForVoiceCommands = new List<string>(); public static List<NamedAudioClip> a4342List = new List<NamedAudioClip>(); static int audioClipDisplayNameIndex = 0; float audioClipStartTime = 0; ActionLoader _actionLoader = null; JSONArray _triggerList; private JSONStorableBool _pushToTalkToggle; private JSONStorableBool _sendActions; private JSONStorableString _triggersTextField; private JSONStorableBool _sendTriggers; private JSONStorableStringChooser _speakerIdChooser; private JSONStorableStringChooser _microphoneDeviceChooser; private JSONNode getConfig() { JSONNode confingJSON = JSONNode.Parse("{}"); confingJSON["sendActions"] = _sendActions.val ? "true" : "false"; confingJSON["sendTriggers"] = _sendTriggers.val ? "true" : "false"; if (_sendTriggers.val) { confingJSON["triggers"] = getTriggerListJSON(); } BL_VoiceControl.latestInstance.BuildLLMActions(); confingJSON["serverURL"] = hostname; confingJSON["speakerId"] = _speakerIdChooser.val.ToString(); confingJSON["pushToTalk"] = _pushToTalkToggle.val ? "true" : "false"; return confingJSON; } private JSONArray getTriggerListJSON() { if (_triggerList == null) { addAllTriggers(); } return _triggerList; } List<String> getTriggerNames() { Atom person = GetContainingAtom(); List<string> actionNames = person.GetStorableIDs(); List<String> stringTriggerList = new List<String>(); foreach (string triggerName in actionNames) { var storable = person.GetStorableByID(triggerName); if (storable.GetType() == typeof(CollisionTrigger)) { stringTriggerList.Add(triggerName); } } return stringTriggerList; } void addAllTriggers() { _triggerList = new JSONArray(); List<String> stringTriggerList = getTriggerNames(); foreach (string triggerName in stringTriggerList) { addTrigger(triggerName); _triggerList.Add(triggerName); } refreshTriggerNamesUI(stringTriggerList); } void refreshTriggerNamesUI(List<String> stringTriggerList) { string listOfTriggers = "Available Triggers:\n"; if (stringTriggerList != null && stringTriggerList.Count > 0) { listOfTriggers += stringTriggerList.Aggregate((acc, x) => acc + "\n" + x); } _triggersTextField.SetVal(listOfTriggers); } void clearAllTriggers() { _triggerList = new JSONArray(); List<string> stringTriggerList = getTriggerNames(); foreach (string triggerName in stringTriggerList) { clearTriggers(triggerName); } refreshTriggerNamesUI(null); } void clearTriggers(string triggerName) { Atom person = GetContainingAtom(); CollisionTrigger trig = person.GetStorableByID(triggerName) as CollisionTrigger; JSONClass trigClass = trig.trigger.GetJSON(); JSONArray trigArray = trigClass["startActions"].AsArray; for (int i = 0; i < trigArray.Count; i++) { if (trigArray[i]["name"].Value == triggerName) { trigArray.Remove(i); } } trig.trigger.RestoreFromJSON(trigClass); } float _timerStarted = 0; private void addTrigger(string triggerName) { clearTriggers(triggerName); string targetName = "Imposter_" + triggerName; JSONStorableAction manualTrigger = new JSONStorableAction(targetName, () => { if (Time.time - _timerStarted > 5) { onTrigger(triggerName); _timerStarted = Time.time; } }); RegisterAction(manualTrigger); Atom person = GetContainingAtom(); CollisionTrigger trig = person.GetStorableByID(triggerName) as CollisionTrigger; if (trig != null) { trig.enabled = true; TriggerActionDiscrete startTrigger; startTrigger = trig.trigger.CreateDiscreteActionStartInternal(); startTrigger.name = targetName; startTrigger.receiverAtom = person; startTrigger.receiver = GetPluginStorableById(person, "Imposter"); startTrigger.receiverTargetName = targetName; } else { ; } } void onTrigger(string triggerName) { if (!_sendTriggers.val) { ; return; } JSONNode triggerMapping = JSON.Parse("{}"); triggerMapping["DeeperVaginaTrigger"] = "Vagina very deep"; triggerMapping["DeepVaginaTrigger"] = "Vagina deeply"; triggerMapping["LabiaTrigger"] = "Labia"; triggerMapping["LipTrigger"] = "Lips"; triggerMapping["lNippleTrigger"] = "Left Nipple"; triggerMapping["rNippleTrigger"] = "Right Nipple"; triggerMapping["MouthTrigger"] = "Mouth"; triggerMapping["ThroatTrigger"] = "Throat"; triggerMapping["VaginaTrigger"] = "Vagina"; JSONNode jSONNode = JSON.Parse("{}"); jSONNode.Add("type", "trigger"); string triggerSimpleName = triggerMapping[triggerName]; if (triggerSimpleName != null) { jSONNode.Add("triggerName", triggerSimpleName); } else { jSONNode.Add("triggerName", triggerName); } JSONNode config = getConfig(); jSONNode.Add("config", config); sendJSON(jSONNode.ToString()); } static JSONStorable GetPluginStorableById(Atom atom, string id) { string storableIdName = atom.GetStorableIDs().FirstOrDefault((string storeId) => { if (string.IsNullOrEmpty(storeId)) { return false; } return storeId.Contains(id); }); if (storableIdName == null) { return null; } return atom.GetStorableByID(storableIdName); } private void connect() { ; buffer = new byte[0]; streaming = false; stream?.Close(); client?.Close(); client = new TcpClient(); client.BeginConnect(hostname, 8000, (IAsyncResult ar) => { ; if (client.Connected) { ; stream = client.GetStream(); StartCoroutine(handshake(3)); ReceiveMessages(); } else { com.ShowError("Could not connect to vamX AI Chat Servers. The servers are under development and may have occasional outages of 24 hours or longer. Please report any issues directly to vamX."); } }, null); } bool leftTriggerDown = false; bool rightTriggerDown = false; bool mouseDown = false; bool isRecordingInBackground = false; float connectedCheckTimer = 5.0f; static float nextActionTime = 0; void Update() { if (!usingImposter) return; if (_pushToTalkToggle.val) { if (!mouseDown && Input.GetMouseButtonDown(1)) { startRecording(); mouseDown = true; } if (mouseDown && Input.GetMouseButtonUp(1)) { stopRecordingAndSend(); mouseDown = false; } float rightTriggerVal = GetRightTriggerVal(); float leftTriggerVal = GetLeftTriggerVal(); if (!rightTriggerDown && rightTriggerVal > 0.05f) { ; startRecording(); rightTriggerDown = true; } if (rightTriggerDown && rightTriggerVal < 0.02f) { ; stopRecordingAndSend(); rightTriggerDown = false; } if (!leftTriggerDown && leftTriggerVal > 0.05f) { ; startRecording(); leftTriggerDown = true; } if (leftTriggerDown && leftTriggerVal < 0.02f) { ; stopRecordingAndSend(); leftTriggerDown = false; } } try { if (a4342List.Count > 0 && (com.breathingOnly || !a133.orgasming)) { imposterSpeaking = true; if (Time.time > audioClipStartTime) { if (a137.headAudios[com.FEMALE_INDEX].CanPlayByPriority(a137.AUDIO_CHAT_AI, a137.AUDIO_PRIORITY_VERY_HIGH_OR_STORY)) { ; a137.headAudios[com.FEMALE_INDEX].PlayNamedAudioClip(a137.AUDIO_CHAT_AI, a137.AUDIO_PRIORITY_VERY_HIGH_OR_STORY, a4342List[0]); a4342List.RemoveAt(0); audioClipStartTime = Time.time + 0.25f; nextActionTime = Time.time + 0.25f; } } } else if (a137.headAudios[com.FEMALE_INDEX].CanPlayByPriority(a137.AUDIO_CHAT_AI, a137.AUDIO_PRIORITY_VERY_HIGH_OR_STORY)) { imposterSpeaking = false; if (actionListForVoiceCommands.Count > 0) { if (Time.time >= nextActionTime) { ; ProcessActionVamX(actionListForVoiceCommands[0], true); actionListForVoiceCommands.RemoveAt(0); nextActionTime = Time.time + 2.5f; } } } } catch (Exception e) { SuperController.LogError("Imposter failed to load head audio: " + e.ToString()); } } public static bool imposterSpeaking = false; byte[] buffer = new byte[0]; bool streaming = false; int bodyLength = 0; private void ReceiveMessages() { while (true) { if (stream.DataAvailable) { try { byte[] container = new byte[client.ReceiveBufferSize]; int bytesRead = stream.Read(container, 0, container.Length); byte[] data = new byte[bytesRead]; Array.Copy(container, 0, data, 0, bytesRead); buffer = buffer.Concat(data).ToArray(); while (true) { if (!streaming && buffer.Length >= 4) { streaming = true; byte[] headerBytes = buffer.Take(4).ToArray(); bodyLength = (headerBytes[0] << 24) | (headerBytes[1] << 16) | (headerBytes[2] << 8) | headerBytes[3]; byte[] newArray = new byte[buffer.Length - 4]; Array.Copy(buffer, 4, newArray, 0, newArray.Length); buffer = newArray; } else if (streaming && buffer.Length >= bodyLength) { byte[] bytes = buffer.Take(bodyLength).ToArray(); byte[] newArray = new byte[buffer.Length - bodyLength]; Array.Copy(buffer, bodyLength, newArray, 0, newArray.Length); buffer = newArray; string message = Encoding.UTF8.GetString(bytes, 0, bytes.Length); streaming = false; onMessageReceived(message); } else { break; } } } catch (Exception e) { ; } } } } private void sendJSON(string jsonString) { if (!client.Connected) { connect(); } byte[] data = Encoding.UTF8.GetBytes(jsonString); int bodyLength = data.Length; int uint32 = data.Length; byte[] headerBytes = new byte[] { (byte)(uint32 >> 24), (byte)(uint32 >> 16), (byte)(uint32 >> 8), (byte)uint32 }; stream.Write(headerBytes, 0, headerBytes.Length); stream.Write(data, 0, data.Length); } private void OnDestroy() { Microphone.End(null); stream.Close(); client.Close(); } public class ActionLoader { private readonly MotionAnimationMaster _motionAnimationMaster; public ActionLoader(MotionAnimationMaster motionAnimationMaster) { _motionAnimationMaster = motionAnimationMaster; } public List<string> getActionNames() { List<string> actionNames = new List<string>(); List<JSONClass> actionJSONs = getActionJSONs(); foreach (JSONClass actionJSON in actionJSONs) { string actionName = actionJSON["name"]; if (actionName != null && !actionName.Equals("")) { actionNames.Add(actionName); } } return actionNames; } public List<JSONClass> getActionJSONs() { JSONArray triggersJSON = _motionAnimationMaster.GetJSON()["triggers"].AsArray; List<JSONClass> allActions = new List<JSONClass>(); foreach (JSONNode triggerJSON in triggersJSON) { JSONArray startActions = triggerJSON["startActions"].AsArray; JSONArray transitionActions = triggerJSON["transitionActions"].AsArray; JSONArray endActions = triggerJSON["endActions"].AsArray; foreach (JSONNode actionJSON in startActions) { allActions.Add(actionJSON.AsObject); } foreach (JSONNode actionJSON in transitionActions) { allActions.Add(actionJSON.AsObject); } foreach (JSONNode actionJSON in endActions) { allActions.Add(actionJSON.AsObject); } } return allActions; } public void trigger(string actionName) { List<JSONClass> actionJSONs = getActionJSONs(); foreach (JSONNode actionJSON in actionJSONs) { string actionNameInList = actionJSON["name"]; if (actionNameInList != null && actionNameInList.Equals(actionName)) { TriggerActionDiscrete triggerActionDiscrete = new TriggerActionDiscrete(); triggerActionDiscrete.RestoreFromJSON(actionJSON.AsObject); triggerActionDiscrete.Trigger(); } } } } public class UIDynamicLabelInput : UIDynamic { public Text label; public InputField input; } private GameObject ourLabelWithInputPrefab; public UIDynamicLabelInput CreateLabelInput(string label, JSONStorableString storable, bool rightSide) { if (ourLabelWithInputPrefab == null) { ourLabelWithInputPrefab = new GameObject("LabelInput"); ourLabelWithInputPrefab.SetActive(false); RectTransform rt = ourLabelWithInputPrefab.AddComponent<RectTransform>(); rt.anchorMax = new Vector2(0, 1); rt.anchorMin = new Vector2(0, 1); rt.offsetMax = new Vector2(535, -500); rt.offsetMin = new Vector2(10, -600); LayoutElement le = ourLabelWithInputPrefab.AddComponent<LayoutElement>(); le.flexibleWidth = 1; le.minHeight = 45; le.minWidth = 350; le.preferredHeight = 45; le.preferredWidth = 500; RectTransform backgroundTransform = manager.configurableScrollablePopupPrefab.transform.Find("Background") as RectTransform; backgroundTransform = UnityEngine.Object.Instantiate(backgroundTransform, ourLabelWithInputPrefab.transform); backgroundTransform.name = "Background"; backgroundTransform.anchorMax = new Vector2(1, 1); backgroundTransform.anchorMin = new Vector2(0, 0); backgroundTransform.offsetMax = new Vector2(0, 0); backgroundTransform.offsetMin = new Vector2(0, -10); RectTransform labelTransform = manager.configurableScrollablePopupPrefab.transform.Find("Button/Text") as RectTransform; ; labelTransform = UnityEngine.Object.Instantiate(labelTransform, ourLabelWithInputPrefab.transform); labelTransform.name = "Text"; labelTransform.anchorMax = new Vector2(0, 1); labelTransform.anchorMin = new Vector2(0, 0); labelTransform.offsetMax = new Vector2(155, -5); labelTransform.offsetMin = new Vector2(5, 0); Text labelText = labelTransform.GetComponent<Text>(); labelText.text = "Name"; labelText.color = Color.white; RectTransform inputTransform = manager.configurableTextFieldPrefab.transform as RectTransform; inputTransform = Instantiate(inputTransform, ourLabelWithInputPrefab.transform); inputTransform.anchorMax = new Vector2(1, 1); inputTransform.anchorMin = new Vector2(0, 0); inputTransform.offsetMax = new Vector2(-5, -5); inputTransform.offsetMin = new Vector2(160, -5); UIDynamicTextField textfield = inputTransform.GetComponent<UIDynamicTextField>(); textfield.backgroundColor = Color.white; LayoutElement layout = textfield.GetComponent<LayoutElement>(); layout.preferredHeight = layout.minHeight = 35; InputField inputfield = textfield.gameObject.AddComponent<InputField>(); inputfield.textComponent = textfield.UItext; RectTransform textTransform = textfield.UItext.rectTransform; textTransform.anchorMax = new Vector2(1, 1); textTransform.anchorMin = new Vector2(0, 0); textTransform.offsetMax = new Vector2(-5, -5); textTransform.offsetMin = new Vector2(10, -5); Destroy(textfield); UIDynamicLabelInput uid = ourLabelWithInputPrefab.AddComponent<UIDynamicLabelInput>(); uid.label = labelText; uid.input = inputfield; } { Transform t = CreateUIElement(ourLabelWithInputPrefab.transform, rightSide); UIDynamicLabelInput uid = t.gameObject.GetComponent<UIDynamicLabelInput>(); storable.inputField = uid.input; uid.label.text = label; t.gameObject.SetActive(true); return uid; } } private AudioClip microphoneClip; private int microphoneFrequency = 16000; int recordingMaxSeconds = 30; public static bool isRecording = false; private string getMicrophoneDeviceName() { string name = _microphoneDeviceChooser.val; if (name != microphoneDeviceSystemDefault) { return name; } return null; } public void InitMicrophone(string microphoneSelected = "") { if (microphoneSelected == "") { microphoneSelected = getMicrophoneDeviceName(); } microphoneClip = Microphone.Start(microphoneSelected, true, recordingMaxSeconds, microphoneFrequency); } private void startRecording() { ; if (!client.Connected) { com.ShowError("AI Chat server not connected. Go to Scene -> AI Chat to reconnect (this will reset your chat history)."); connect(); return; } StartCoroutine(recordData()); ; } public static float lastStopRecordingAndSend = 0; private void stopRecordingAndSend() { isRecording = false; } public IEnumerator recordData() { isRecording = true; ; int startPositionInSamples = Microphone.GetPosition(getMicrophoneDeviceName()); int channels = microphoneClip.channels; float startTime = Time.time; while (isRecording) { yield return new WaitForSeconds(0.01f); } if (Time.time - startTime < 0.4f) { ; yield break; } yield return new WaitForSeconds(0.5f); int endPositionInSamples = Microphone.GetPosition(getMicrophoneDeviceName()); int changePositionInSamples = endPositionInSamples - startPositionInSamples; string base64String; if (endPositionInSamples < startPositionInSamples) { ; int samplesToEnd = microphoneClip.samples - startPositionInSamples; var samplesToEndArray = new float[samplesToEnd * channels]; microphoneClip.GetData(samplesToEndArray, startPositionInSamples); var samplesFromStartArray = new float[endPositionInSamples * channels]; microphoneClip.GetData(samplesFromStartArray, 0); float[] totalSamples = new float[samplesToEndArray.Length + samplesFromStartArray.Length]; samplesToEndArray.CopyTo(totalSamples, 0); samplesFromStartArray.CopyTo(totalSamples, samplesToEndArray.Length); byte[] bytesData = new byte[totalSamples.Length * 2]; int rescaleFactor = 32768; for (int i = 0; i < totalSamples.Length; i++) { short value = (short)(totalSamples[i] * rescaleFactor); byte[] byteArr = BitConverter.GetBytes(value); byteArr.CopyTo(bytesData, i * 2); } base64String = Convert.ToBase64String(bytesData); } else { var samples = new float[changePositionInSamples * channels]; microphoneClip.GetData(samples, startPositionInSamples); byte[] bytesData = new byte[samples.Length * 2]; int rescaleFactor = 32768; for (int i = 0; i < samples.Length; i++) { short value = (short)(samples[i] * rescaleFactor); byte[] byteArr = BitConverter.GetBytes(value); byteArr.CopyTo(bytesData, i * 2); } base64String = Convert.ToBase64String(bytesData); } ; JSONNode jSONNode = JSON.Parse("{}"); if (microphoneFrequency == 16000) { jSONNode.Add("type", "wav16"); } else { jSONNode.Add("type", "wav"); } jSONNode.Add("payload", base64String); JSONNode config = getConfig(); jSONNode.Add("config", config); jSONNode.Add("secret", secret); sendJSON(jSONNode.ToString()); yield break; } public static class SavWav { const int HEADER_SIZE = 44; public static bool Save(string filename, AudioClip clip) { if (!filename.ToLower().EndsWith(".wav")) { filename += ".wav"; } var filepath = "Saves/PluginData/vamX/" + filename; List<byte> wavFile = new List<byte>(); WriteHeader(wavFile, clip); ConvertAndWrite(wavFile, clip); FileManagerSecure.WriteAllBytes(filepath, wavFile.ToArray()); return true; } public static AudioClip TrimSilence(AudioClip clip, float min) { var samples = new float[clip.samples]; clip.GetData(samples, 0); return TrimSilence(new List<float>(samples), min, clip.channels, clip.frequency); } public static AudioClip TrimSilence(List<float> samples, float min, int channels, int hz) { return TrimSilence(samples, min, channels, hz, false, false); } public static AudioClip TrimSilence(List<float> samples, float min, int channels, int hz, bool _3D, bool stream) { int i; for (i = 0; i < samples.Count; i++) { if (Mathf.Abs(samples[i]) > min) { break; } } samples.RemoveRange(0, i); for (i = samples.Count - 1; i > 0; i--) { if (Mathf.Abs(samples[i]) > min) { break; } } samples.RemoveRange(i, samples.Count - i); var clip = AudioClip.Create("TempClip", samples.Count, channels, hz, _3D, stream); clip.SetData(samples.ToArray(), 0); return clip; } static void ConvertAndWrite(List<byte> fileStream, AudioClip clip) { var samples = new float[clip.samples]; clip.GetData(samples, 0); Int16[] intData = new Int16[samples.Length]; Byte[] bytesData = new Byte[samples.Length * 2]; int rescaleFactor = 32767; for (int i = 0; i < samples.Length; i++) { intData[i] = (short)(samples[i] * rescaleFactor); Byte[] byteArr = new Byte[2]; byteArr = BitConverter.GetBytes(intData[i]); byteArr.CopyTo(bytesData, i * 2); } fileStream.AddRange(bytesData); } static void AddRange(List<byte> fileStream, Byte[] byteArray, int maxSize) { Array.Resize(ref byteArray, maxSize); fileStream.AddRange(byteArray); } static void WriteHeader(List<byte> fileStream, AudioClip clip) { var hz = clip.frequency; var channels = clip.channels; var samples = clip.samples; Byte[] riff = System.Text.Encoding.UTF8.GetBytes("RIFF"); AddRange(fileStream, riff, 4); Byte[] chunkSize = BitConverter.GetBytes(fileStream.Count - 8); AddRange(fileStream, chunkSize, 4); Byte[] wave = System.Text.Encoding.UTF8.GetBytes("WAVE"); AddRange(fileStream, wave, 4); Byte[] fmt = System.Text.Encoding.UTF8.GetBytes("fmt "); AddRange(fileStream, fmt, 4); Byte[] subChunk1 = BitConverter.GetBytes(16); AddRange(fileStream, subChunk1, 4); UInt16 two = 2; UInt16 one = 1; Byte[] audioFormat = BitConverter.GetBytes(one); AddRange(fileStream, audioFormat, 2); Byte[] numChannels = BitConverter.GetBytes(channels); AddRange(fileStream, numChannels, 2); Byte[] sampleRate = BitConverter.GetBytes(hz); AddRange(fileStream, sampleRate, 4); Byte[] byteRate = BitConverter.GetBytes(hz * channels * 2); AddRange(fileStream, byteRate, 4); UInt16 blockAlign = (ushort)(channels * 2); AddRange(fileStream, BitConverter.GetBytes(blockAlign), 2); UInt16 bps = 16; Byte[] bitsPerSample = BitConverter.GetBytes(bps); AddRange(fileStream, bitsPerSample, 2); Byte[] datastring = System.Text.Encoding.UTF8.GetBytes("data"); AddRange(fileStream, datastring, 4); Byte[] subChunk2 = BitConverter.GetBytes(samples * channels * 2); AddRange(fileStream, subChunk2, 4); } } } } 